# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# For developer releases
%global devrel %{nil}

Summary:	Interface to the DNS resolver
Name:		perl-Net-DNS
Version:	0.74
Release:	1.0.cf.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://www.net-dns.org/
Source0:	http://www.net-dns.org/download/Net-DNS-%{version}%{?devrel}.tar.gz
Patch0:		Net-DNS-0.66-UTF8.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Digest::BubbleBabble)
BuildRequires:	perl(Digest::HMAC) >= 1.01
BuildRequires:	perl(Digest::MD5) >= 2.13
BuildRequires:	perl(Digest::SHA) >= 5.23
BuildRequires:	perl(Encode)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(IO::Select)
BuildRequires:	perl(IO::Socket) >= 1.24
BuildRequires:	perl(IO::Socket::INET)
BuildRequires:	perl(IO::Socket::INET6)
BuildRequires:	perl(lib)
BuildRequires:	perl(MIME::Base64) >= 2.11
BuildRequires:	perl(Net::LibIDN)
BuildRequires:	perl(Socket)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(vars)
BuildRequires:	perl(XSLoader)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(XSLoader)

# Don't "provide" private Perl libs
%global __provides_exclude ^DNS\\.so

%description
Net::DNS is a collection of Perl modules that act as a Domain Name
System (DNS) resolver. It allows the programmer to perform DNS queries
that are beyond the capabilities of gethostbyname and gethostbyaddr.

The programmer should be somewhat familiar with the format of a DNS
packet and its various sections. See RFC 1035 or DNS and BIND (Albitz
& Liu) for details.

%package Nameserver
Summary:	DNS server for Perl
Group:		Development/Libraries

%description Nameserver
Instances of the "Net::DNS::Nameserver" class represent DNS server
objects.

%prep
%setup -q -n Net-DNS-%{version}%{?devrel}

# Fix encoding of ChangeLog
%patch0 -p1

# Fix shellbangs in demo scripts
sed -i -e 's|^#!/usr/local/bin/perl|#!/usr/bin/perl|' demo/*

# Drop exec permissions from demo scripts to avoid doc-file dependencies
chmod -c -x demo/*

%build
perl Makefile.PL --online-tests --IPv6-tests \
	INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README* TODO demo/
%{perl_vendorarch}/Net/
%{perl_vendorarch}/auto/Net/
%{_mandir}/man3/Net::DNS.3pm*
%{_mandir}/man3/Net::DNS::*
# perl-Net-DNS-Nameserver
%exclude %{perl_vendorarch}/Net/DNS/Nameserver.pm
%exclude %{_mandir}/man3/Net::DNS::Nameserver.3pm*
# Win32 files
%exclude %{perl_vendorarch}/Net/DNS/Resolver/cygwin.pm
%exclude %{_mandir}/man3/Net::DNS::Resolver::cygwin.3*
%exclude %{perl_vendorarch}/Net/DNS/Resolver/MSWin32.pm
%exclude %{_mandir}/man3/Net::DNS::Resolver::MSWin32.3*

%files Nameserver
%defattr(-,root,root,-)
%{perl_vendorarch}/Net/DNS/Nameserver.pm
%{_mandir}/man3/Net::DNS::Nameserver.3pm*

%changelog
* Thu Jan 16 2014 Paul Howarth <paul@city-fan.org> 0.74-1.0.cf
- Update to 0.74
  - Fix nameserver crashes on malformed UDP query (CPAN RT#91306)
  - TSIG: fix incorrectly generated %%algbyval table (CPAN RT#91241)
  - Add CAA, EUI48 and EUI64 RR implementation

* Fri Nov 29 2013 Paul Howarth <paul@city-fan.org> 0.73-1.0.cf
- Update to 0.73
  - Feature CPAN RT#53610: add TSIG validation support
  - Feature CPAN RT#84468: TSIG: add support for HMAC-SHA1 .. HMAC-SHA512
  - Fix CPAN RT#88778: $update->unique_push() does not work as advertised
  - Fix CPAN RT#88744: nameserver crashes on malformed TCP query
  - Fix CPAN RT#84601/CPAN RT#81942: fix memory leak on packet cleanup
  - Fix CPAN RT#84110: incorrect parsing of PTR records in zonefile
  - Fix CPAN RT#83755: erroneous attempt to invoke Net::LibIDN in Domain.pm
  - Fix CPAN RT#83078: can't locate Net/DNS/Resolver/linux.pm in @INC
  - Fix CPAN RT#83078: eval{ ... }; if ($@) { ... }; broken by threads?
  - Fix CPAN RT#83075: ZoneFile.pm wrongly rejects $TTL 0 directive
  - Fix CPAN RT#82621: error string empty after failed TCP query
  - Fix CPAN RT#82296: IPv6 with embedded IPv4 address not mapped to ip6.arpa
  - Fix CPAN RT#82294: perl taint removed in Domain and Text objects

* Mon Jul 22 2013 Paul Howarth <paul@city-fan.org> 0.72-4.0.cf
- Perl 5.18 rebuild

* Sat Dec 29 2012 Paul Howarth <paul@city-fan.org> 0.72-1.0.cf
- Update to 0.72
  - Fix CPAN RT#82148: nxrrset fails to ignore RDATA 
  - Fix CPAN RT#82134: TSIG key and algorithm names not downcased in digest,
    Class not forced to ANY
  - Fix CPAN RT#82063: yxrrset, nxrrset and rr_del functions should force zero
    TTL
  - Fix CPAN RT#82047: clarify documentation to indicate that header counts may
    differ from the number of RRs present if a packet is corrupt
  - Fix CPAN RT#81941: clarify documentation to make clear that bgread will not
    switch to TCP when a truncated packet is received

* Sat Dec 15 2012 Paul Howarth <paul@city-fan.org> 0.71-1.0.cf
- Update to 0.71
  - Add workaround for SpamAssassin (CPAN RT#81760); the rdatastr method for
    TXT RRs will return unconditionally quoted rdata fields to work around an
    issue with updating SpamAssassin rules (this workaround will be reverted
    after the release of a version of SpamAssassin that resolves the issue)
  - Fix memory leak on packet cleanup; the back-reference via the header
    attribute (with xbody) caused the garbage collector not to clean a packet,
    so the header is now explicitly cleaned via Net::DNS::Packet::DESTROY
  - Fix TSIG initialization: uninitialised algorithm attribute caused
    signature generation to fail silently when creating a TSIG signed packet

* Thu Dec 13 2012 Paul Howarth <paul@city-fan.org> 0.70-2.0.cf
- Update to 0.70_1
  - Disambiguate ANY in rr_del auxilliary function (CPAN RT#81869)
  - Fix test failures on Perl 5.8.5 .. 5.8.8 due to lc(), uc() and case
    insensitive regex matching being broken for UTF8 (CPAN RT#81756)
  - NXDOMAIN no longer reported by $resolver->errorstring (CPAN RT#81787)
  - Allow zero in format, tag and algorithm fields of CERT RR (CPAN RT#81814)
  - Substitute last owner for leading spaces in multiline zonefile RR
    (CPAN RT#81786)
  - Make use of new extended header modus operandi for OPT records also in the
    resolver, preventing a warning (CPAN RT#77444)
- Drop warnings patch, issue now fixed upstream
- Drop provides filter, no longer needed

* Thu Dec  6 2012 Paul Howarth <paul@city-fan.org> 0.70-1.0.cf
- Update to 0.70
  - Add NID L32 L64 LP resource records + unit tests to MANIFEST
- Include demo files as documentation

* Thu Dec  6 2012 Paul Howarth <paul@city-fan.org> 0.69-1.0.cf
- Update to 0.69 (see Changes for details)
- Win32 resolvers renamed, so fix up %%exclude entries
- Drop BR: perl(Text::ParseWords), no longer needed
- Add patch to inhibit warnings on Perl 5.8 that are not only ugly, they break
  the test suite

* Sun Jul  1 2012 Paul Howarth <paul@city-fan.org> 0.68-2.0.cf
- BR:/R: perl(XSLoader)
- BR: perl(base), perl(Carp), perl(constant), perl(Data::Dumper),
  perl(Digest::HMAC_MD5), perl(Encode), perl(Exporter), perl(File::Spec),
  perl(IO::Select), perl(IO::Socket), perl(IO::Socket::INET), perl(lib),
  perl(MIME::Base64), perl(Net::LibIDN), perl(Socket), perl(Test::More) and
  perl(Text::ParseWords)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation
  - Drop patch for "useless constant" warnings as we always have Perl ≥ 5.8.5

* Wed Feb  1 2012 Paul Howarth <paul@city-fan.org> 0.68-1.0.cf
- Update to 0.68
  - CPAN RT#72314: Let a Net::DNS::Nameserver bind on
    Net::DNS::Nameserver::DEFAULT_ADDR as a last resort
  - Fix to suppress false warnings about subroutine profiles on ancient
    versions of perl
  - Fix to avoid constants with value undef, which prevents unwanted code from
    being optimized away on ancient versions of perl
  - Fix code error in PTR.pm, canonical RDATA not downcased
  - Enhancement to clarify the function of parse and data methods, by renaming
    them to decode and encode respectively
  - Feature IDN query support: Queries for domain names containing non-ASCII
    characters are now possible on Unicode platforms with CPAN Net::LibIDN
    installed
  - Introduction of Mailbox.pm module that will be used in the future to
    represent RDATA components containing DNS coded RFC822 mailbox addresses
  - Introduction of Text.pm module that will be used in the future to represent
    RDATA components containing text
- Update patch to suppress "useless use of constant in void context" warnings

* Mon Nov  7 2011 Paul Howarth <paul@city-fan.org> 0.67-1.0.cf
- Update to 0.67 (lots of bugfixes and enhancements - see Changes for details)
- Drop now-redundant build requirement perl(Net::IP)
- Add patch to suppress highly verbose "useless use of constant in void
  context" warnings with perl < 5.8.5

* Tue Jul  5 2011 Paul Howarth <paul@city-fan.org> 0.66-4.0.cf
- Rebuild for perl 5.14.1 in Rawhide
- Fix provides filter to work with rpm 4.9 properly
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun  3 2011 Paul Howarth <paul@city-fan.org> 0.66-3.0.cf
- Use patch rather than iconv to fix ChangeLog encoding
- Nobody else likes macros for commands

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 0.66-2.1.cf
- Rebuild for perl 5.12.1 in Rawhide

* Fri May  7 2010 Paul Howarth <paul@city-fan.org> 0.66-2.0.cf
- Fix dist tag to work with RHEL6 Beta

* Wed Dec 30 2009 Paul Howarth <paul@city-fan.org> 0.66-1.0.cf
- Update to 0.66 (lots of bugfixes and enhancements - see Changes for details)
- BR: perl(Digest::SHA)
- Dist tag for Rawhide no longer needs special-casing

* Tue Sep 22 2009 Paul Howarth <paul@city-fan.org> 0.65-1.2.cf
- Use %%{?perl_default_filter} for provides filtering

* Mon Mar  2 2009 Paul Howarth <paul@city-fan.org> 0.65-1.1.cf
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Tue Jan 27 2009 Paul Howarth <paul@city-fan.org> 0.65-1.0.CF
- Update to 0.65

* Thu Jan 22 2009 Paul Howarth <paul@city-fan.org> 0.64-1.0.CF
- Update to 0.64
- Tweak dist tag macros to work on Rawhide with three-part releasenum
- Use Makefile.PL options to supply answers to build-time questions instead of
  piping in answers from a separate shell

* Mon Feb 11 2008 Paul Howarth <paul@city-fan.org> 0.63-1.0.CF
- Update to 0.63

* Wed Jan  2 2008 Paul Howarth <paul@city-fan.org> 0.62-1.0.CF
- Update to 0.62

* Fri Dec 21 2007 Paul Howarth <paul@city-fan.org> 0.61-4.0.CF
- Split Nameserver.pm into subpackage, per recommendation from
  upstream maintainer Dick Franks.
  - Separates the server bits from the client bits.
  - Removes the dependancy on perl(Net::IP) from perl-Net-DNS
- Recode Changes file as UTF8
- Add buildreq perl(IO::Socket::INET6) for extra test cover
- Don't package Cygwin resolver

* Thu Aug  2 2007 Paul Howarth <paul@city-fan.org> 0.61-1
- update to 0.61
- clarify license as GPL+ (GPL v1 or later) or Artistic (same as perl)

* Mon Jun 25 2007 Paul Howarth <paul@city-fan.org> 0.60-1
- update to 0.60

* Tue Jun  5 2007 Paul Howarth <paul@city-fan.org> 0.59-3
- fix dist tag for Fedora 7 onwards
- add buildreq perl(ExtUtils::MakeMaker)

* Tue Oct  3 2006 Paul Howarth <paul@city-fan.org> 0.59-2
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Tue Sep 19 2006 Paul Howarth <paul@city-fan.org> 0.59-1
- update to 0.59
- fix argument order for find with -depth

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> 0.58-2
- Fix distribution tags for development releases

* Wed Jul  5 2006 Paul Howarth <paul@city-fan.org> 0.58-1
- Update to 0.58
- Define %%{__id_u} in a more portable way

* Mon Feb 27 2006 Paul Howarth <paul@city-fan.org> 0.57-1
- Update to 0.57
- inet6 test now fixed upstream and doesn't need patching

* Tue Feb 21 2006 Paul Howarth <paul@city-fan.org> 0.56-1
- Update to 0.56
- Support building on CentOS
- Fix inet6 test, broken if IPV6 support not enabled

* Wed Dec 14 2005 Paul Howarth <paul@city-fan.org> 0.55-1
- Update to 0.55

* Thu Dec  8 2005 Paul Howarth <paul@city-fan.org> 0.54-1
- Update to 0.54
- Remove macros __perl_version and __perl_package
- Remove buildroot unconditionally in %%clean and %%install
- Simplify distribution-detection
- Use sed to modify MANIFEST rather than scripting arpund grep
- Simplify compiler optmization flag setup
- Don't use macros in paths for build-time commands, hardcode them instead
- Own directories properly
- Add buildreqs perl(Test::Pod) and perl(Digest::BubbleBabble) for tests

* Tue Jul 26 2005 Paul Howarth <paul@city-fan.org> 0.53-1
- Update to 0.53

* Mon Jul  4 2005 Paul Howarth <paul@city-fan.org> 0.52-1
- Update to 0.52

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> 0.51_02-1
- Update to 0.51_02
- Rewrite spec file in (mainly) Fedora Extras style
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Add perl(Net::IP) buildrequire

* Fri Apr  1 2005 Paul Howarth <paul@city-fan.org> 0.49-1
- Update to 0.49

* Tue Aug 24 2004 Paul Howarth <paul@city-fan.org> 0.48-1
- Update to 0.48
- Tidy up of spec file

* Wed Apr 14 2004 Paul Howarth <paul@city-fan.org> 0.47-1
- Update to 0.47.
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuilt from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 0.46-1
- Update to 0.46

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 0.45-2
- Unified spec file for Red Hat and Fedora Core

* Fri Jan 09 2004 Paul Howarth <paul@city-fan.org> 0.45-1.fc1
- update to 0.45
- removed buildarch: noarch as there is now compiled C in this module
- remove Win32.pm that creates bad dependency
- updated specfile to use more macros and add fedora-release dependency

* Mon Oct 20 2003 Chip Turner <cturner@redhat.com> 0.31-3.2
- fix interactive build issue

* Mon Jan 27 2003 Chip Turner <cturner@redhat.com>
- version bump and rebuild

* Tue Dec 10 2002 Chip Turner <cturner@redhat.com>
- update to latest version from CPAN

* Tue Aug  6 2002 Chip Turner <cturner@redhat.com>
- automated release bump and build

* Tue Aug  6 2002 Chip Turner <cturner@localhost.localdomain>
- update to 0.26

* Thu Jun 27 2002 Chip Turner <cturner@redhat.com>
- description update

* Sat Jun 15 2002 cturner@redhat.com
- Specfile autogenerated

